/* DEFS: message MBlockDataMsg{
unsigned char data[];
}
;
 */
#ifndef CK_TEMPLATES_ONLY
void *CMessage_MBlockDataMsg::operator new(size_t s){
  return MBlockDataMsg::alloc(__idx, s, 0, 0);
}
void *CMessage_MBlockDataMsg::operator new(size_t s,const int pb){
  return MBlockDataMsg::alloc(__idx, s, 0, pb);
}
void *CMessage_MBlockDataMsg::operator new(size_t s, int* sz){
  return MBlockDataMsg::alloc(__idx, s, sz, 0);
}
void *CMessage_MBlockDataMsg::operator new(size_t s, int* sz,const int pb){
  return MBlockDataMsg::alloc(__idx, s, sz, pb);
}
void *CMessage_MBlockDataMsg::operator new(size_t s, int sz0, const int p) {
  int sizes[1];
  sizes[0] = sz0;
  return MBlockDataMsg::alloc(__idx, s, sizes, p);
}
void* CMessage_MBlockDataMsg::alloc(int msgnum, size_t sz, int *sizes, int pb) {
  int offsets[2];
  offsets[0] = ALIGN8(sz);
  if(sizes==0)
    offsets[1] = offsets[0];
  else
    offsets[1] = offsets[0] + ALIGN8(sizeof(unsigned char)*sizes[0]);
  MBlockDataMsg *newmsg = (MBlockDataMsg *) CkAllocMsg(msgnum, offsets[1], pb);
  newmsg->data = (unsigned char *) ((char *)newmsg + offsets[0]);
  return (void *) newmsg;
}
void* CMessage_MBlockDataMsg::pack(MBlockDataMsg *msg) {
  msg->data = (unsigned char *) ((char *)msg->data - (char *)msg);
  return (void *) msg;
}
MBlockDataMsg* CMessage_MBlockDataMsg::unpack(void* buf) {
  MBlockDataMsg *msg = (MBlockDataMsg *) buf;
  msg->data = (unsigned char *) ((size_t)msg->data + (char *)msg);
  return msg;
}
int CMessage_MBlockDataMsg::__idx=0;
#endif


/* DEFS: array MBlockChunk: ArrayElement{
MBlockChunk(CkMigrateMessage* impl_msg);
MBlockChunk(const CkArrayID &threads);
void recv(MBlockDataMsg* impl_msg);
void reductionResult(CkReductionMsg* impl_msg);
};
 */
#ifndef CK_TEMPLATES_ONLY
 int CkIndex_MBlockChunk::__idx=0;
#endif
#ifndef CK_TEMPLATES_ONLY
/* DEFS: MBlockChunk(CkMigrateMessage* impl_msg);
 */

/* DEFS: MBlockChunk(const CkArrayID &threads);
 */
void CProxyElement_MBlockChunk::insert(const CkArrayID &threads, int onPE, const CkEntryOptions *impl_e_opts)
{ 
  //Marshall: const CkArrayID &threads
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkArrayID &)threads;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkArrayID &)threads;
  }
   ckInsert((CkArrayMessage *)impl_msg,CkIndex_MBlockChunk::__idx_MBlockChunk_marshall1,onPE);
}

/* DEFS: void recv(MBlockDataMsg* impl_msg);
 */
void CProxyElement_MBlockChunk::recv(MBlockDataMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_MBlockChunk::__idx_recv_MBlockDataMsg);
}

/* DEFS: void reductionResult(CkReductionMsg* impl_msg);
 */
void CProxyElement_MBlockChunk::reductionResult(CkReductionMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_MBlockChunk::__idx_reductionResult_CkReductionMsg);
}
/* DEFS: MBlockChunk(CkMigrateMessage* impl_msg);
 */
 int CkIndex_MBlockChunk::__idx_MBlockChunk_CkMigrateMessage=0;
void CkIndex_MBlockChunk::_call_MBlockChunk_CkMigrateMessage(void* impl_msg,MBlockChunk * impl_obj)
{
  new (impl_obj) MBlockChunk((CkMigrateMessage*)impl_msg);
}

/* DEFS: MBlockChunk(const CkArrayID &threads);
 */
CkArrayID CProxy_MBlockChunk::ckNew(const CkArrayID &threads, const CkArrayOptions &opts, const CkEntryOptions *impl_e_opts)
{ 
  //Marshall: const CkArrayID &threads
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkArrayID &)threads;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkArrayID &)threads;
  }
   return ckCreateArray((CkArrayMessage *)impl_msg,CkIndex_MBlockChunk::__idx_MBlockChunk_marshall1,opts);
}
 int CkIndex_MBlockChunk::__idx_MBlockChunk_marshall1=0;
void CkIndex_MBlockChunk::_call_MBlockChunk_marshall1(void* impl_msg,MBlockChunk * impl_obj)
{
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const CkArrayID &threads*/
  PUP::fromMem implP(impl_buf);
  CkArrayID threads; implP|threads;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  new (impl_obj) MBlockChunk(threads);
}
int CkIndex_MBlockChunk::_callmarshall_MBlockChunk_marshall1(char* impl_buf,MBlockChunk * impl_obj) {
  /*Unmarshall pup'd fields: const CkArrayID &threads*/
  PUP::fromMem implP(impl_buf);
  CkArrayID threads; implP|threads;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  new (impl_obj) MBlockChunk(threads);
  return implP.size();
}
void CkIndex_MBlockChunk::_marshallmessagepup_MBlockChunk_marshall1(PUP::er &implDestP,void *impl_msg) {
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const CkArrayID &threads*/
  PUP::fromMem implP(impl_buf);
  CkArrayID threads; implP|threads;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  if (implDestP.hasComments()) implDestP.comment("threads");
  implDestP|threads;
}

/* DEFS: void recv(MBlockDataMsg* impl_msg);
 */
void CProxy_MBlockChunk::recv(MBlockDataMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_MBlockChunk::__idx_recv_MBlockDataMsg);
}
 int CkIndex_MBlockChunk::__idx_recv_MBlockDataMsg=0;
void CkIndex_MBlockChunk::_call_recv_MBlockDataMsg(void* impl_msg,MBlockChunk * impl_obj)
{
  impl_obj->recv((MBlockDataMsg*)impl_msg);
}

/* DEFS: void reductionResult(CkReductionMsg* impl_msg);
 */
void CProxy_MBlockChunk::reductionResult(CkReductionMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_MBlockChunk::__idx_reductionResult_CkReductionMsg);
}
 int CkIndex_MBlockChunk::__idx_reductionResult_CkReductionMsg=0;
void CkIndex_MBlockChunk::_call_reductionResult_CkReductionMsg(void* impl_msg,MBlockChunk * impl_obj)
{
  impl_obj->reductionResult((CkReductionMsg*)impl_msg);
}
/* DEFS: MBlockChunk(CkMigrateMessage* impl_msg);
 */

/* DEFS: MBlockChunk(const CkArrayID &threads);
 */

/* DEFS: void recv(MBlockDataMsg* impl_msg);
 */
void CProxySection_MBlockChunk::recv(MBlockDataMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_MBlockChunk::__idx_recv_MBlockDataMsg);
}

/* DEFS: void reductionResult(CkReductionMsg* impl_msg);
 */
void CProxySection_MBlockChunk::reductionResult(CkReductionMsg* impl_msg) 
{
  ckCheck();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_MBlockChunk::__idx_reductionResult_CkReductionMsg);
}
#endif /*CK_TEMPLATES_ONLY*/
#ifndef CK_TEMPLATES_ONLY
void CkIndex_MBlockChunk::__register(const char *s, size_t size) {
  __idx = CkRegisterChare(s, size);
  CkRegisterBase(__idx, CkIndex_ArrayElement::__idx);
// REG: MBlockChunk(CkMigrateMessage* impl_msg);
  __idx_MBlockChunk_CkMigrateMessage = CkRegisterEp("MBlockChunk(CkMigrateMessage* impl_msg)",
     (CkCallFnPtr)_call_MBlockChunk_CkMigrateMessage, 0, __idx, 0);
  CkRegisterMigCtor(__idx, __idx_MBlockChunk_CkMigrateMessage);

// REG: MBlockChunk(const CkArrayID &threads);
  __idx_MBlockChunk_marshall1 = CkRegisterEp("MBlockChunk(const CkArrayID &threads)",
     (CkCallFnPtr)_call_MBlockChunk_marshall1, CkMarshallMsg::__idx, __idx, 0+CK_EP_NOKEEP);
  CkRegisterMarshallUnpackFn(__idx_MBlockChunk_marshall1,(CkMarshallUnpackFn)_callmarshall_MBlockChunk_marshall1);
  CkRegisterMessagePupFn(__idx_MBlockChunk_marshall1,(CkMessagePupFn)_marshallmessagepup_MBlockChunk_marshall1);

// REG: void recv(MBlockDataMsg* impl_msg);
  __idx_recv_MBlockDataMsg = CkRegisterEp("recv(MBlockDataMsg* impl_msg)",
     (CkCallFnPtr)_call_recv_MBlockDataMsg, CMessage_MBlockDataMsg::__idx, __idx, 0);

// REG: void reductionResult(CkReductionMsg* impl_msg);
  __idx_reductionResult_CkReductionMsg = CkRegisterEp("reductionResult(CkReductionMsg* impl_msg)",
     (CkCallFnPtr)_call_reductionResult_CkReductionMsg, CMessage_CkReductionMsg::__idx, __idx, 0);
}
#endif

#ifndef CK_TEMPLATES_ONLY
void _registermblock(void)
{
  static int _done = 0; if(_done) return; _done = 1;
/* REG: message MBlockDataMsg{
unsigned char data[];
}
;
*/
CMessage_MBlockDataMsg::__register("MBlockDataMsg", sizeof(MBlockDataMsg),(CkPackFnPtr) MBlockDataMsg::pack,(CkUnpackFnPtr) MBlockDataMsg::unpack);

      _registerInitCall(MBlockProcInit,0);

/* REG: array MBlockChunk: ArrayElement{
MBlockChunk(CkMigrateMessage* impl_msg);
MBlockChunk(const CkArrayID &threads);
void recv(MBlockDataMsg* impl_msg);
void reductionResult(CkReductionMsg* impl_msg);
};
*/
  CkIndex_MBlockChunk::__register("MBlockChunk", sizeof(MBlockChunk));

}
#endif
