/* DEFS: message callbackMsg;
 */
#ifndef CK_TEMPLATES_ONLY
void *CMessage_callbackMsg::operator new(size_t s){
  return callbackMsg::alloc(__idx, s, 0, 0);
}
void *CMessage_callbackMsg::operator new(size_t s,const int pb){
  return callbackMsg::alloc(__idx, s, 0, pb);
}
void *CMessage_callbackMsg::operator new(size_t s, int* sz){
  return callbackMsg::alloc(__idx, s, sz, 0);
}
void *CMessage_callbackMsg::operator new(size_t s, int* sz,const int pb){
  return callbackMsg::alloc(__idx, s, sz, pb);
}
void* CMessage_callbackMsg::alloc(int msgnum, size_t sz, int *sizes, int pb) {
  int offsets[1];
  offsets[0] = ALIGN8(sz);
  callbackMsg *newmsg = (callbackMsg *) CkAllocMsg(msgnum, offsets[0], pb);
  return (void *) newmsg;
}
void* CMessage_callbackMsg::pack(callbackMsg *msg) {
  return (void *) msg;
}
callbackMsg* CMessage_callbackMsg::unpack(void* buf) {
  callbackMsg *msg = (callbackMsg *) buf;
  return msg;
}
int CMessage_callbackMsg::__idx=0;
#endif

/* DEFS: array taskGraphArray: ArrayElement{
taskGraphArray(CkMigrateMessage* impl_msg);
taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults);
void requestData(const CkArrayIndexMax &from);
void depositData(const CkPointer<taskGraphSolver> &data);
void deleteElement(void);
};
 */
#ifndef CK_TEMPLATES_ONLY
 int CkIndex_taskGraphArray::__idx=0;
#endif
#ifndef CK_TEMPLATES_ONLY
/* DEFS: taskGraphArray(CkMigrateMessage* impl_msg);
 */

/* DEFS: taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults);
 */
void CProxyElement_taskGraphArray::insert(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults, int onPE, const CkEntryOptions *impl_e_opts)
{ 
  //Marshall: const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkVec<CkArrayIndexMax> &)deps;
    //Have to cast away const-ness to get pup routine
    implP|(CkPointer<taskGraphSolver> &)data;
    //Have to cast away const-ness to get pup routine
    implP|(CkCallback &)returnResults;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkVec<CkArrayIndexMax> &)deps;
    //Have to cast away const-ness to get pup routine
    implP|(CkPointer<taskGraphSolver> &)data;
    //Have to cast away const-ness to get pup routine
    implP|(CkCallback &)returnResults;
  }
   ckInsert((CkArrayMessage *)impl_msg,CkIndex_taskGraphArray::__idx_taskGraphArray_marshall1,onPE);
}

/* DEFS: void requestData(const CkArrayIndexMax &from);
 */
void CProxyElement_taskGraphArray::requestData(const CkArrayIndexMax &from, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: const CkArrayIndexMax &from
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkArrayIndexMax &)from;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkArrayIndexMax &)from;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_taskGraphArray::__idx_requestData_marshall2);
}

/* DEFS: void depositData(const CkPointer<taskGraphSolver> &data);
 */
void CProxyElement_taskGraphArray::depositData(const CkPointer<taskGraphSolver> &data, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: const CkPointer<taskGraphSolver> &data
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkPointer<taskGraphSolver> &)data;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkPointer<taskGraphSolver> &)data;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_taskGraphArray::__idx_depositData_marshall3);
}

/* DEFS: void deleteElement(void);
 */
void CProxyElement_taskGraphArray::deleteElement(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_taskGraphArray::__idx_deleteElement_void);
}
/* DEFS: taskGraphArray(CkMigrateMessage* impl_msg);
 */
 int CkIndex_taskGraphArray::__idx_taskGraphArray_CkMigrateMessage=0;
void CkIndex_taskGraphArray::_call_taskGraphArray_CkMigrateMessage(void* impl_msg,taskGraphArray * impl_obj)
{
  new (impl_obj) taskGraphArray((CkMigrateMessage*)impl_msg);
}

/* DEFS: taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults);
 */
CkArrayID CProxy_taskGraphArray::ckNew(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults, const CkArrayOptions &opts, const CkEntryOptions *impl_e_opts)
{ 
  //Marshall: const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkVec<CkArrayIndexMax> &)deps;
    //Have to cast away const-ness to get pup routine
    implP|(CkPointer<taskGraphSolver> &)data;
    //Have to cast away const-ness to get pup routine
    implP|(CkCallback &)returnResults;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkVec<CkArrayIndexMax> &)deps;
    //Have to cast away const-ness to get pup routine
    implP|(CkPointer<taskGraphSolver> &)data;
    //Have to cast away const-ness to get pup routine
    implP|(CkCallback &)returnResults;
  }
   return ckCreateArray((CkArrayMessage *)impl_msg,CkIndex_taskGraphArray::__idx_taskGraphArray_marshall1,opts);
}
 int CkIndex_taskGraphArray::__idx_taskGraphArray_marshall1=0;
void CkIndex_taskGraphArray::_call_taskGraphArray_marshall1(void* impl_msg,taskGraphArray * impl_obj)
{
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults*/
  PUP::fromMem implP(impl_buf);
  CkVec<CkArrayIndexMax> deps; implP|deps;
  CkPointer<taskGraphSolver> data; implP|data;
  CkCallback returnResults; implP|returnResults;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  new (impl_obj) taskGraphArray(deps, data, returnResults);
}
int CkIndex_taskGraphArray::_callmarshall_taskGraphArray_marshall1(char* impl_buf,taskGraphArray * impl_obj) {
  /*Unmarshall pup'd fields: const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults*/
  PUP::fromMem implP(impl_buf);
  CkVec<CkArrayIndexMax> deps; implP|deps;
  CkPointer<taskGraphSolver> data; implP|data;
  CkCallback returnResults; implP|returnResults;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  new (impl_obj) taskGraphArray(deps, data, returnResults);
  return implP.size();
}
void CkIndex_taskGraphArray::_marshallmessagepup_taskGraphArray_marshall1(PUP::er &implDestP,void *impl_msg) {
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults*/
  PUP::fromMem implP(impl_buf);
  CkVec<CkArrayIndexMax> deps; implP|deps;
  CkPointer<taskGraphSolver> data; implP|data;
  CkCallback returnResults; implP|returnResults;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  if (implDestP.hasComments()) implDestP.comment("deps");
  implDestP|deps;
  if (implDestP.hasComments()) implDestP.comment("data");
  implDestP|data;
  if (implDestP.hasComments()) implDestP.comment("returnResults");
  implDestP|returnResults;
}

/* DEFS: void requestData(const CkArrayIndexMax &from);
 */
void CProxy_taskGraphArray::requestData(const CkArrayIndexMax &from, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: const CkArrayIndexMax &from
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkArrayIndexMax &)from;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkArrayIndexMax &)from;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_taskGraphArray::__idx_requestData_marshall2);
}
 int CkIndex_taskGraphArray::__idx_requestData_marshall2=0;
void CkIndex_taskGraphArray::_call_requestData_marshall2(void* impl_msg,taskGraphArray * impl_obj)
{
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const CkArrayIndexMax &from*/
  PUP::fromMem implP(impl_buf);
  CkArrayIndexMax from; implP|from;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  impl_obj->requestData(from);
}
int CkIndex_taskGraphArray::_callmarshall_requestData_marshall2(char* impl_buf,taskGraphArray * impl_obj) {
  /*Unmarshall pup'd fields: const CkArrayIndexMax &from*/
  PUP::fromMem implP(impl_buf);
  CkArrayIndexMax from; implP|from;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  impl_obj->requestData(from);
  return implP.size();
}
void CkIndex_taskGraphArray::_marshallmessagepup_requestData_marshall2(PUP::er &implDestP,void *impl_msg) {
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const CkArrayIndexMax &from*/
  PUP::fromMem implP(impl_buf);
  CkArrayIndexMax from; implP|from;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  if (implDestP.hasComments()) implDestP.comment("from");
  implDestP|from;
}

/* DEFS: void depositData(const CkPointer<taskGraphSolver> &data);
 */
void CProxy_taskGraphArray::depositData(const CkPointer<taskGraphSolver> &data, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: const CkPointer<taskGraphSolver> &data
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkPointer<taskGraphSolver> &)data;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkPointer<taskGraphSolver> &)data;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_taskGraphArray::__idx_depositData_marshall3);
}
 int CkIndex_taskGraphArray::__idx_depositData_marshall3=0;
void CkIndex_taskGraphArray::_call_depositData_marshall3(void* impl_msg,taskGraphArray * impl_obj)
{
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const CkPointer<taskGraphSolver> &data*/
  PUP::fromMem implP(impl_buf);
  CkPointer<taskGraphSolver> data; implP|data;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  impl_obj->depositData(data);
}
int CkIndex_taskGraphArray::_callmarshall_depositData_marshall3(char* impl_buf,taskGraphArray * impl_obj) {
  /*Unmarshall pup'd fields: const CkPointer<taskGraphSolver> &data*/
  PUP::fromMem implP(impl_buf);
  CkPointer<taskGraphSolver> data; implP|data;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  impl_obj->depositData(data);
  return implP.size();
}
void CkIndex_taskGraphArray::_marshallmessagepup_depositData_marshall3(PUP::er &implDestP,void *impl_msg) {
  char *impl_buf=((CkMarshallMsg *)impl_msg)->msgBuf;
  /*Unmarshall pup'd fields: const CkPointer<taskGraphSolver> &data*/
  PUP::fromMem implP(impl_buf);
  CkPointer<taskGraphSolver> data; implP|data;
  impl_buf+=CK_ALIGN(implP.size(),16);
  /*Unmarshall arrays:*/
  if (implDestP.hasComments()) implDestP.comment("data");
  implDestP|data;
}

/* DEFS: void deleteElement(void);
 */
void CProxy_taskGraphArray::deleteElement(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckBroadcast(impl_amsg, CkIndex_taskGraphArray::__idx_deleteElement_void);
}
 int CkIndex_taskGraphArray::__idx_deleteElement_void=0;
void CkIndex_taskGraphArray::_call_deleteElement_void(void* impl_msg,taskGraphArray * impl_obj)
{
  CkFreeSysMsg(impl_msg);
  impl_obj->deleteElement();
}
/* DEFS: taskGraphArray(CkMigrateMessage* impl_msg);
 */

/* DEFS: taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults);
 */

/* DEFS: void requestData(const CkArrayIndexMax &from);
 */
void CProxySection_taskGraphArray::requestData(const CkArrayIndexMax &from, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: const CkArrayIndexMax &from
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkArrayIndexMax &)from;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkArrayIndexMax &)from;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_taskGraphArray::__idx_requestData_marshall2);
}

/* DEFS: void depositData(const CkPointer<taskGraphSolver> &data);
 */
void CProxySection_taskGraphArray::depositData(const CkPointer<taskGraphSolver> &data, const CkEntryOptions *impl_e_opts) 
{
  ckCheck();
  //Marshall: const CkPointer<taskGraphSolver> &data
  int impl_off=0;
  { //Find the size of the PUP'd data
    PUP::sizer implP;
    //Have to cast away const-ness to get pup routine
    implP|(CkPointer<taskGraphSolver> &)data;
    impl_off+=implP.size();
  }
  CkMarshallMsg *impl_msg=CkAllocateMarshallMsg(impl_off,impl_e_opts);
  { //Copy over the PUP'd data
    PUP::toMem implP((void *)impl_msg->msgBuf);
    //Have to cast away const-ness to get pup routine
    implP|(CkPointer<taskGraphSolver> &)data;
  }
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_taskGraphArray::__idx_depositData_marshall3);
}

/* DEFS: void deleteElement(void);
 */
void CProxySection_taskGraphArray::deleteElement(void) 
{
  ckCheck();
  void *impl_msg = CkAllocSysMsg();
  CkArrayMessage *impl_amsg=(CkArrayMessage *)impl_msg;
  impl_amsg->array_setIfNotThere(CkArray_IfNotThere_buffer);
  ckSend(impl_amsg, CkIndex_taskGraphArray::__idx_deleteElement_void);
}
#endif /*CK_TEMPLATES_ONLY*/
#ifndef CK_TEMPLATES_ONLY
void CkIndex_taskGraphArray::__register(const char *s, size_t size) {
  __idx = CkRegisterChare(s, size);
  CkRegisterBase(__idx, CkIndex_ArrayElement::__idx);
// REG: taskGraphArray(CkMigrateMessage* impl_msg);
  __idx_taskGraphArray_CkMigrateMessage = CkRegisterEp("taskGraphArray(CkMigrateMessage* impl_msg)",
     (CkCallFnPtr)_call_taskGraphArray_CkMigrateMessage, 0, __idx, 0);
  CkRegisterMigCtor(__idx, __idx_taskGraphArray_CkMigrateMessage);

// REG: taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults);
  __idx_taskGraphArray_marshall1 = CkRegisterEp("taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults)",
     (CkCallFnPtr)_call_taskGraphArray_marshall1, CkMarshallMsg::__idx, __idx, 0+CK_EP_NOKEEP);
  CkRegisterMarshallUnpackFn(__idx_taskGraphArray_marshall1,(CkMarshallUnpackFn)_callmarshall_taskGraphArray_marshall1);
  CkRegisterMessagePupFn(__idx_taskGraphArray_marshall1,(CkMessagePupFn)_marshallmessagepup_taskGraphArray_marshall1);

// REG: void requestData(const CkArrayIndexMax &from);
  __idx_requestData_marshall2 = CkRegisterEp("requestData(const CkArrayIndexMax &from)",
     (CkCallFnPtr)_call_requestData_marshall2, CkMarshallMsg::__idx, __idx, 0+CK_EP_NOKEEP);
  CkRegisterMarshallUnpackFn(__idx_requestData_marshall2,(CkMarshallUnpackFn)_callmarshall_requestData_marshall2);
  CkRegisterMessagePupFn(__idx_requestData_marshall2,(CkMessagePupFn)_marshallmessagepup_requestData_marshall2);

// REG: void depositData(const CkPointer<taskGraphSolver> &data);
  __idx_depositData_marshall3 = CkRegisterEp("depositData(const CkPointer<taskGraphSolver> &data)",
     (CkCallFnPtr)_call_depositData_marshall3, CkMarshallMsg::__idx, __idx, 0+CK_EP_NOKEEP);
  CkRegisterMarshallUnpackFn(__idx_depositData_marshall3,(CkMarshallUnpackFn)_callmarshall_depositData_marshall3);
  CkRegisterMessagePupFn(__idx_depositData_marshall3,(CkMessagePupFn)_marshallmessagepup_depositData_marshall3);

// REG: void deleteElement(void);
  __idx_deleteElement_void = CkRegisterEp("deleteElement(void)",
     (CkCallFnPtr)_call_deleteElement_void, 0, __idx, 0);
}
#endif

#ifndef CK_TEMPLATES_ONLY
void _registertaskGraph(void)
{
  static int _done = 0; if(_done) return; _done = 1;
/* REG: message callbackMsg;
*/
CMessage_callbackMsg::__register("callbackMsg", sizeof(callbackMsg),(CkPackFnPtr) callbackMsg::pack,(CkUnpackFnPtr) callbackMsg::unpack);

/* REG: array taskGraphArray: ArrayElement{
taskGraphArray(CkMigrateMessage* impl_msg);
taskGraphArray(const CkVec<CkArrayIndexMax> &deps, const CkPointer<taskGraphSolver> &data, const CkCallback &returnResults);
void requestData(const CkArrayIndexMax &from);
void depositData(const CkPointer<taskGraphSolver> &data);
void deleteElement(void);
};
*/
  CkIndex_taskGraphArray::__register("taskGraphArray", sizeof(taskGraphArray));

}
#endif
